
%--------------------------------------------------------------------------
% DEMO LEBESGUE CONSTANT FOR SET POINTS ON THE UNIT SQUARE.
%--------------------------------------------------------------------------

clear all;

vdeg=1:20;
example=1; % 1: OUR SETS. IN CASE OF NEED, PUT YOUR SETS NAME AT LINE 29
%            AND YOUR FUNCTION AT LINE 65 ("example=0").
family_type=1; % 1: FEKETE 2: LEBESGUE.

%--------------------------------------------------------------------------
% HERE THE MAIN PROGRAM STARTS.
%--------------------------------------------------------------------------


%----------------------------------
% USEFUL INFO.
%----------------------------------
if example == 1
    switch family_type
        case 1
            s='set_square_fek';
        case 2
            s='set_square_leb';
    end
else % PUT THE NAME OF YOUR FUNCTION HERE (WITHOUT .m EXTENSION).
    s='experiments';
end

diaryname=cat(2,'diary_',s,'.m');

diary on; diary(diaryname);

fprintf('\n \t ');
uu=cat(2,'function pts=',s,'(deg)');
fprintf(uu);

fprintf('\n \n \n \t switch deg \n')

t=[];

for ii=1:length(vdeg)

    deg=vdeg(ii);

    %######################################################################
    % IMPORTANT: PUT YOUR SET HERE IF NEEDED!!!.
    %######################################################################

    switch example
        case 0 % YOUR FILE.
            pts=your_function(deg);
        case 1
            switch family_type
                case 1
                    pts=set_square_fek(deg);
                case 2
                    pts=set_square_leb(deg);
            end
        case 2
            pts=pdpts(deg);
        case 3
            switch family_type
                case 1
                    [pts,t]=set_optpd_fek(deg);
                case 2
                    [pts,t]=set_optpd_leb(deg);
            end
    end

    [lebloc,detloc,condloc]=do_stats(deg,pts,[],t);
    leb(ii)=lebloc;
    dets(ii)=abs(detloc);
    conds(ii,1)=condloc;

end
fprintf('\n \n \t otherwise \n');
fprintf('\n \t pts=pdpts(deg);');
fprintf('\n \n \t end \n');

%-------------------------
% STATS.
%--------------------------
fprintf('\n \t %% STATS');
fprintf('\n \t %% |DEGR|  LEBESGUE   | ABS.DET.VAND.| COND. VAND. |')
fprintf('\n \t stats_matrix=[');
for ii=1:length(vdeg)
    fprintf('\n \t %2.0f %1.5e %1.5e %1.5e',vdeg(ii),leb(ii),...
        abs(dets(ii)),conds(ii,1));
end
fprintf('\n \t ]; \n');


%-----------------------
% FINAL SUMMARY.
%-----------------------

fprintf('\n \t %% ------------------------------------------------- ');
fprintf('\n \t %% |DEGR|  LEBESGUE   | ABS.DET.VAND.| COND. VAND. |')
fprintf('\n \t %% ------------------------------------------------- ');

format short e
for ii=1:length(vdeg)
    fprintf('\n \t %% | %2.0f | %1.5e | %1.5e | %1.5e |',vdeg(ii),leb(ii),...
        abs(dets(ii)),conds(ii,1));
end
fprintf('\n \t %% ------------------------------------------------- \n \n');
diary off;

